/*
 * Flight_Data_Analyzer.java
 *
 * Created on December 2, 2004, 11:01 AM
 */

/**
 *
 * @author  swensonk
 */
//import java.awt.*;
//import java.awt.event.*;
//import javax.swing.*;
//import java.io.*;
//import java.text.*;
//import java.util.*;
import java.awt.image.BufferedImage;

import java.io.*;
import java.util.*;

public class Flight_Data_Analyzer extends javax.swing.JFrame {
   private static final String DATA_DIR = "C:\\Download\\Rocketry\\Flight_Data_Recorder\\Flight_Data\\";
   private static final int ciTIMER  = 0;
   private static final int ciTEMP   = 1;
   private static final int ciGFORCE = 2;
   private static final int ciPSIA   = 3;
   
   /** Creates new form Flight_Data_Analyzer */
   public Flight_Data_Analyzer() {
      initComponents();
      //*** Load all Data Files (most recent first) ***
      jcboFile.removeAllItems();
      File[] af = new File(DATA_DIR).listFiles();
      Arrays.sort(af);
      int iCount = af.length - 1;
      while ( iCount >= 0 )
      {  jcboFile.addItem(af[iCount].toString().substring(DATA_DIR.length()));
         iCount--;
      }
   }
   
   /** This method is called from within the constructor to
    * initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is
    * always regenerated by the Form Editor.
    */
   private void initComponents() {//GEN-BEGIN:initComponents
      lblFDATitle = new javax.swing.JLabel();
      jcboFile = new javax.swing.JComboBox();
      jcboxTimes10Mult = new javax.swing.JCheckBox();
      jbtnExit = new javax.swing.JButton();
      canvas = new javax.swing.JLabel();
      jbtnSaveNextDataFile = new javax.swing.JButton();
      jScrollPane1 = new javax.swing.JScrollPane();
      jtxtaNextDataFile = new javax.swing.JTextArea();

      getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

      addWindowListener(new java.awt.event.WindowAdapter() {
         public void windowClosing(java.awt.event.WindowEvent evt) {
            exitForm(evt);
         }
      });

      lblFDATitle.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      lblFDATitle.setText("FDA");
      getContentPane().add(lblFDATitle, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 5, 984, 20));

      jcboFile.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            jcboFileActionPerformed(evt);
         }
      });

      getContentPane().add(jcboFile, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 30, 250, -1));

      jcboxTimes10Mult.setSelected(true);
      jcboxTimes10Mult.setText("Times 10 Multiplier");
      jcboxTimes10Mult.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            jcboxTimes10MultActionPerformed(evt);
         }
      });

      getContentPane().add(jcboxTimes10Mult, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 30, -1, -1));

      jbtnExit.setMnemonic('E');
      jbtnExit.setText("Exit");
      jbtnExit.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            jbtnExitActionPerformed(evt);
         }
      });

      getContentPane().add(jbtnExit, new org.netbeans.lib.awtextra.AbsoluteConstraints(910, 30, 100, 20));

      canvas.setMaximumSize(new java.awt.Dimension(1000, 600));
      canvas.setMinimumSize(new java.awt.Dimension(1000, 600));
      canvas.setPreferredSize(new java.awt.Dimension(1000, 600));
      getContentPane().add(canvas, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 70, -1, 600));

      jbtnSaveNextDataFile.setText("Save Data");
      jbtnSaveNextDataFile.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            jbtnSaveNextDataFileActionPerformed(evt);
         }
      });

      getContentPane().add(jbtnSaveNextDataFile, new org.netbeans.lib.awtextra.AbsoluteConstraints(730, 30, 100, 20));

      jScrollPane1.setViewportView(jtxtaNextDataFile);

      getContentPane().add(jScrollPane1, new org.netbeans.lib.awtextra.AbsoluteConstraints(460, 29, 260, 40));

      pack();
   }//GEN-END:initComponents

   private void jbtnSaveNextDataFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnSaveNextDataFileActionPerformed
      // TODO add your handling code here:
      //*** Test for No Data ***//
      if ( jtxtaNextDataFile.getText().length() == 0 )
      {  javax.swing.JOptionPane.showMessageDialog(null, "There is no Data to Save", "No Data", javax.swing.JOptionPane.WARNING_MESSAGE);
         return;
      }
      if ( jtxtaNextDataFile.getText().toLowerCase().indexOf("Temperature".toLowerCase()) == -1 ||
           jtxtaNextDataFile.getText().toLowerCase().indexOf("GForce".toLowerCase()) == -1 ||
           jtxtaNextDataFile.getText().toLowerCase().indexOf("PSIA".toLowerCase()) == -1 )
      {  javax.swing.JOptionPane.showMessageDialog(null, "Data Not in Correct Format", "Incorrect Format", javax.swing.JOptionPane.WARNING_MESSAGE);
         if ( javax.swing.JOptionPane.showConfirmDialog(null, "Shall I Continue Anyway?", "Continue?", javax.swing.JOptionPane.YES_NO_OPTION, javax.swing.JOptionPane.QUESTION_MESSAGE ) == javax.swing.JOptionPane.NO_OPTION )
            return;
      }

      String sFileName = new String();
      sFileName = "Flight_Data" + 
                  "_" + Calendar.getInstance().get(Calendar.YEAR) +
                  "_" + (Calendar.getInstance().get(Calendar.MONTH) + 1) +
                  "_" + Calendar.getInstance().get(Calendar.DAY_OF_MONTH);
      //*** Loop while FileName Exists ***//
      javax.swing.JOptionPane.showMessageDialog(null, "Data Saved in \"" + sFileName + "\"", "Data Saved", javax.swing.JOptionPane.INFORMATION_MESSAGE);
   }//GEN-LAST:event_jbtnSaveNextDataFileActionPerformed

   private void jcboxTimes10MultActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcboxTimes10MultActionPerformed
      // TODO add your handling code here:
      drawData();
   }//GEN-LAST:event_jcboxTimes10MultActionPerformed

   private void jbtnExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnExitActionPerformed
      // TODO add your handling code here:
      System.exit(0);
   }//GEN-LAST:event_jbtnExitActionPerformed

   private void jcboFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcboFileActionPerformed
      // TODO add your handling code here:
      drawData();
      //pack();
   }//GEN-LAST:event_jcboFileActionPerformed
   
   /** Exit the Application */
   private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
      System.exit(0);
   }//GEN-LAST:event_exitForm
   
   /**
    * @param args the command line arguments
    */
   public static void main(String args[]) {
      new Flight_Data_Analyzer().show();
   }
   
   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.JLabel canvas;
   private javax.swing.JScrollPane jScrollPane1;
   private javax.swing.JButton jbtnExit;
   private javax.swing.JButton jbtnSaveNextDataFile;
   private javax.swing.JComboBox jcboFile;
   private javax.swing.JCheckBox jcboxTimes10Mult;
   private javax.swing.JTextArea jtxtaNextDataFile;
   private javax.swing.JLabel lblFDATitle;
   // End of variables declaration//GEN-END:variables

   //***********************************************************************************************************************//
   private Vector[] loadFile(String strFilename)
   {  //*** Read File into an Array[4] of Vectors ***//
      Vector[] aV = new Vector[4];
      aV[ciTIMER]  = new Vector(0);
      aV[ciTEMP]   = new Vector(0);
      aV[ciGFORCE] = new Vector(0);
      aV[ciPSIA]   = new Vector(0);
      
      try
      {  //*** Open File ***/
         BufferedReader file = null;
         file = new BufferedReader(new FileReader(DATA_DIR + strFilename));
         //*** Read File into Vector[] ***/
         String sLine = null;
         boolean bIncludeTimer = false;
         int iTimer = 0;
         //*** Read First (Header) Line ***//
         sLine = file.readLine();
         System.out.println("sLine=" + sLine);
         //*** Test for Containing "Timer" ***//
         bIncludeTimer = (sLine.indexOf("Timer") != -1);
         iTimer = 0;
         while ( (sLine = file.readLine()) != null )
         {  System.out.println("sLine=" + sLine);
            java.util.StringTokenizer st = new java.util.StringTokenizer(sLine,",");
            //*** Test File Includes "Temperature" Column AND static has more Tokens ***/
            if ( bIncludeTimer == true && st.hasMoreTokens() == true )
               //*** Add Timer from Data File ***//
               aV[ciTIMER].add(st.nextToken());
            else
               //*** Add Timer from Position Count ***//
               aV[ciTIMER].add(""+iTimer);
            //*** Test for Temperature Data and Add to Vector ***//
            if ( st.hasMoreTokens() == true )
               aV[ciTEMP].add(st.nextToken());
            //*** Test for GForce Data and Add to Vector ***//
            if ( st.hasMoreTokens() == true )
               aV[ciGFORCE].add(st.nextToken());
            //*** Test for PSIA Data and Add to Vector ***//
            if ( st.hasMoreTokens() == true )
               aV[ciPSIA].add(st.nextToken());
            iTimer++;
         }
         file.close();
      }
      catch(IOException e){System.out.println("loadFile:Exception=" + e.getMessage());System.out.flush();}
      
      //*** Trim to Size ***//
      aV[ciTIMER].trimToSize();
      aV[ciTEMP].trimToSize();
      aV[ciGFORCE].trimToSize();
      aV[ciTIMER].trimToSize();

      //*** Return Vector ***//
      return aV;
   }
   //***********************************************************************************************************************//
   private void drawData()
   {  //*** Load Data into Vector ***//
      final int iMAXX   = 1000;
      final int iMAXY   =  600;
      final int iOFFSET =  500;
      final int iMULTPLYER = (jcboxTimes10Mult.isSelected()==true)?10:1;
      final double dTIMERMULTIPLYER = 1.0;
      final double dTEMPMULTIPLYER = 5.0;
      final double dGFORCEMULTIPLYER = 100.0;
      final double dPSIAMULTIPLYER = 25.0;//0.25;
      Vector[] aV = loadFile(jcboFile.getSelectedItem().toString());
      java.awt.Image img = createImage(iMAXX,iMAXY);
      java.awt.Graphics imgg = img.getGraphics();
      
      //*** Draw Ticks every 0.1 Seconds for 1 Minute ***//
      imgg.setColor(java.awt.Color.LIGHT_GRAY);
      for ( int x = 0 ; x < iMAXX ; x++ )
      {  if ( (x % 10) == 0 )
            imgg.setColor(java.awt.Color.DARK_GRAY);
         else
            imgg.setColor(java.awt.Color.LIGHT_GRAY);
         imgg.drawLine(x*10,0,x*10,iMAXX);
      }
      //*** Draw Horizontal Ticks every 100 Units ***//
      imgg.setColor(java.awt.Color.LIGHT_GRAY);
      for ( int x = 0 ; x < iMAXX ; x+=100 )
      {  if ( x == iOFFSET )
            imgg.setColor(java.awt.Color.DARK_GRAY);
         else
            imgg.setColor(java.awt.Color.LIGHT_GRAY);
         imgg.drawLine(0,x,iMAXX,x);
      }
      
      int x = 1;
      while( x < aV[ciTEMP].size() )
      {  //*** Time ***//
         imgg.setColor(java.awt.Color.BLACK);
         imgg.drawLine((x-1)*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciTIMER].get(x-1).toString())*dTIMERMULTIPLYER),x*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciTIMER].get(x).toString())*dTIMERMULTIPLYER));
         //*** Temperature ***//
         imgg.setColor(java.awt.Color.RED);
         imgg.drawLine((x-1)*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciTEMP].get(x-1).toString())*dTEMPMULTIPLYER),x*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciTEMP].get(x).toString())*dTEMPMULTIPLYER));
         //*** GForce ***//
         imgg.setColor(java.awt.Color.BLUE);
         imgg.drawLine((x-1)*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciGFORCE].get(x-1).toString())*dGFORCEMULTIPLYER),x*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciGFORCE].get(x).toString())*dGFORCEMULTIPLYER));
         //*** PSIA ***//
         imgg.setColor(new java.awt.Color(0,127,0));
         imgg.drawLine((x-1)*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciPSIA].get(x-1).toString())*dPSIAMULTIPLYER),x*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciPSIA].get(x).toString())*dPSIAMULTIPLYER));
         x++;
      }
      //*** Legend ***//  
      imgg.setColor(java.awt.Color.RED);
      imgg.drawString("Temperature 0 - " + iOFFSET/dTEMPMULTIPLYER + " F",810,540);
      imgg.setColor(java.awt.Color.BLUE);
      imgg.drawString("Acceleration 0 - " + iOFFSET/dGFORCEMULTIPLYER + " G",810,560);
      imgg.setColor(new java.awt.Color(0,127,0));
      imgg.drawString("Altitude 0 - " + iOFFSET/dPSIAMULTIPLYER + " Feet",810,580);
      
      //*** Finally, Draw the Thing! ***//
      canvas.getGraphics().drawImage(img,1,1,iMAXX,iMAXY,null);
   }
}
